unit Fmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Db, Grids, DBGrids, DBCtrls, ComCtrls, ExtCtrls, StdCtrls;

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Buffer1: TMenuItem;
    Standard1: TMenuItem;
    Old1: TMenuItem;
    Inserted1: TMenuItem;
    Modified1: TMenuItem;
    Deleted1: TMenuItem;
    Option1: TMenuItem;
    ChachedUpdate1: TMenuItem;
    BookMark1: TMenuItem;
    Get1: TMenuItem;
    Go1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DS: TDataSource;
    Data1: TMenuItem;
    Insert1: TMenuItem;
    Append1: TMenuItem;
    ApplyUpdates1: TMenuItem;
    CancelUpdates1: TMenuItem;
    CommitUpdates1: TMenuItem;
    Cloner1: TMenuItem;
    SaveFile1: TMenuItem;
    LoadFile1: TMenuItem;
    RevertRecord1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GetBook21: TMenuItem;
    GoBook21: TMenuItem;
    CompareBook121: TMenuItem;
    ReadOnly1: TMenuItem;
    Filter1: TMenuItem;
    Filtered1: TMenuItem;
    SetfilterValue1: TMenuItem;
    Panel3: TPanel;
    ActiveBuffer: TEdit;
    Label1: TLabel;
    Data: TMenuItem;
    Insert2: TMenuItem;
    Append2: TMenuItem;
    CommitRecord1: TMenuItem;
    Sort1: TMenuItem;
    SortOnCHSTR1: TMenuItem;
    SortOnCHFLOAT1: TMenuItem;
    Show1: TMenuItem;
    Detail1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure Append1Click(Sender: TObject);
    procedure ChachedUpdate1Click(Sender: TObject);
    procedure ApplyUpdates1Click(Sender: TObject);
    procedure CancelUpdates1Click(Sender: TObject);
    procedure CommitUpdates1Click(Sender: TObject);
    procedure Old1Click(Sender: TObject);
    procedure Inserted1Click(Sender: TObject);
    procedure Modified1Click(Sender: TObject);
    procedure Deleted1Click(Sender: TObject);
    procedure Standard1Click(Sender: TObject);
    procedure Get1Click(Sender: TObject);
    procedure Go1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Dtail1Click(Sender: TObject);
    procedure Cloner1Click(Sender: TObject);
    procedure SaveFile1Click(Sender: TObject);
    procedure LoadFile1Click(Sender: TObject);
    procedure RevertRecord1Click(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure GetBook21Click(Sender: TObject);
    procedure GoBook21Click(Sender: TObject);
    procedure ReadOnly1Click(Sender: TObject);
    procedure Filtered1Click(Sender: TObject);
    procedure SetfilterValue1Click(Sender: TObject);
    procedure DSDataChange(Sender: TObject; Field: TField);
    procedure Insert2Click(Sender: TObject);
    procedure Append2Click(Sender: TObject);
    procedure CommitRecord1Click(Sender: TObject);
    procedure SortOnCHSTR1Click(Sender: TObject);
    procedure SortOnCHFLOAT1Click(Sender: TObject);
    procedure Detail1Click(Sender: TObject);
  private
    { Dclarations prives }
    Book1,Book2 : tbookMark ;
  public
    { Dclarations publiques }
    procedure UpdateUI;
  end;

var
  FrmMain: TFrmMain;


implementation

uses Dmtest, RLVirDS, Fdebug;

{$R *.DFM}

procedure TFrmMain.Open1Click(Sender: TObject);
begin
     DS.DataSet.open;
end;

procedure TFrmMain.Close1Click(Sender: TObject);
begin
    DS.DataSet.close;
end;

procedure TFrmMain.Insert1Click(Sender: TObject);
var
   I : integer;
   TmpDs : TVirtualDataset;
begin
   TmpDs := (DS.DataSet as TVirtualDataset);
   TmpDs.DisableControls;
   Try
   { for I := 1 to 300 do
    begin
      Tmpds.InsertRawRecord(['insert raw rec' + intToStr(i),i,''])
    end; }
   for I := 1 to 300 do
   begin
     TmpDS.InsertRaw;
     Tmpds.FieldByName('CHSTR').value := 'insert raw rec' + intToStr(i);
     Tmpds.FieldByName('CHINT').value := i;
     Tmpds.FieldByName('CHFLOAT').value := 1.8 + i;
     TmpDs.PostRaw;
   end;
   finally
     Tmpds.EnableControls;
   end;

end;

procedure TFrmMain.Append1Click(Sender: TObject);
var
   I : integer;
   TmpDs : TVirtualDataset;
begin
   TmpDs := (DS.DataSet as TVirtualDataset);
   TmpDs.DisableControls;
   Try
   for I := 1 to 300 do
   begin
     TmpDS.AppendRaw;
     Tmpds.FieldByName('CHSTR').value := 'append raw rec' + intToStr(i);
     Tmpds.FieldByName('CHINT').value := i;
     Tmpds.FieldByName('CHFLOAT').value := 1.5 + i;
     TmpDs.PostRaw;
   end;
   finally
     Tmpds.EnableControls;
   end;

end;

procedure TFrmMain.ChachedUpdate1Click(Sender: TObject);
begin
  ChachedUpdate1.Checked := not ChachedUpdate1.checked;
 (DS.DataSet as TVirtualDataset).CachedUpdates := ChachedUpdate1.checked;

end;

procedure TFrmMain.ApplyUpdates1Click(Sender: TObject);
begin
  Writedebug('apply Updates');
  (DS.DataSet as TVirtualDataset).ApplyUpdates;
end;

procedure TFrmMain.CancelUpdates1Click(Sender: TObject);
begin
   Writedebug('Cancel Updates');
  (DS.DataSet as TVirtualDataset).CancelUpdates;
end;

procedure TFrmMain.CommitUpdates1Click(Sender: TObject);
begin
   Writedebug('Commit Updates');
  (DS.DataSet as TVirtualDataset).CommitUpdates;
end;

procedure TFrmMain.Old1Click(Sender: TObject);
begin
  {if not (DS.DataSet as TVirtualDataset).UpdatesPending then
  begin
     ShowMessage('no updates pending');
     exit;
  end; }
  (DS.DataSet as TVirtualDataset).BrowseBuffer := brold;
  Old1.Checked := true;
end;

procedure TFrmMain.Inserted1Click(Sender: TObject);
begin
  if not (DS.DataSet as TVirtualDataset).UpdatesPending then
  begin
     ShowMessage('no updates pending');
     exit;
  end;
  (DS.DataSet as TVirtualDataset).BrowseBuffer := brInserted;
  Inserted1.Checked := true;
end;

procedure TFrmMain.Modified1Click(Sender: TObject);
begin
  if not (DS.DataSet as TVirtualDataset).UpdatesPending then
  begin
     ShowMessage('no updates pending');
     exit;
  end;
   (DS.DataSet as TVirtualDataset).BrowseBuffer := brModified;
   Modified1.Checked := true;
end;

procedure TFrmMain.Deleted1Click(Sender: TObject);
begin
  if not (DS.DataSet as TVirtualDataset).UpdatesPending then
  begin
     ShowMessage('no updates pending');
     exit;
  end;
   (DS.DataSet as TVirtualDataset).BrowseBuffer := brDeleted;
   Deleted1.Checked := true;
end;

procedure TFrmMain.Standard1Click(Sender: TObject);
begin
   (DS.DataSet as TVirtualDataset).BrowseBuffer := brStandard;
   Standard1.Checked := true;
end;

procedure TFrmMain.Get1Click(Sender: TObject);
begin
   if assigned(book1) then
     Ds.dataset.FreeBookmark(Book1);
   Book1 := Ds.dataset.GetBookmark;
end;

procedure TFrmMain.Go1Click(Sender: TObject);
begin
  if assigned(book1) then
     Ds.dataset.GotoBookmark(Book1);
end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
 UpdateUi;
end;

procedure TFrmMain.Dtail1Click(Sender: TObject);
begin
     Dmtst.Showdet;
end;

procedure TFrmMain.Cloner1Click(Sender: TObject);
var
 tmpDs : TEventDataset;
 TmpFrm : TFrmMain;
begin
  tmpFrm := TFrmMain.create(Application);
  TmpDs := TEventDataset.create(application);
  (DS.dataset as TvirtualDataset).clone(tmpds);
  TmpFrm.ds.dataset := tmpDs;
  Tmpfrm.ShowModal;
  TmpFrm.free;
  TmpDS.free;

end;

procedure TFrmMain.SaveFile1Click(Sender: TObject);
begin
  if (SaveDialog1.Execute) then
     (Ds.dataset as TvirtualDataset).SaveTofile(SaveDialog1.FileName);
end;

procedure TFrmMain.LoadFile1Click(Sender: TObject);
begin
   if (OpenDialog1.Execute) then
     (Ds.dataset as TvirtualDataset).LoadFromfile(OpenDialog1.FileName);
   UpdateUI;  
end;

procedure TFrmMain.RevertRecord1Click(Sender: TObject);
begin
   Writedebug('Revert current record');
  (DS.DataSet as TVirtualDataset).RevertRecord;
end;

procedure TFrmMain.DBGrid1TitleClick(Column: TColumn);
begin
   Writedebug('Sort on' + Column.FieldName);
  (DS.DataSet as TVirtualDataset).SortOn(column.fieldname,false,false);
end;

procedure TFrmMain.UpdateUI;
var
  TmpVds : TvirtualDataset;
begin
   TmpVds := DS.dataset as TvirtualDataset;
   ChachedUpdate1.Checked := TmpVds.CachedUpdates;
   Standard1.Checked := (TmpVds.BrowseBuffer = brStandard);
   Old1.Checked := (TmpVds.BrowseBuffer = brOld);
   Inserted1.Checked := (TmpVds.BrowseBuffer = brInserted);
   Modified1.Checked := (TmpVds.BrowseBuffer = brModified);
   Deleted1.Checked := (TmpVds.BrowseBuffer = brDeleted);
   ReadOnly1.Checked := TmpVds.ReadOnly;
   Filtered1.Checked := TmpVds.Filtered;
end;


procedure TFrmMain.GetBook21Click(Sender: TObject);
begin
   if assigned(book2) then
     Ds.dataset.FreeBookmark(Book2);
   Book2 := Ds.dataset.GetBookmark;
end;

procedure TFrmMain.GoBook21Click(Sender: TObject);
begin
    if assigned(book2) then
     Ds.dataset.GotoBookmark(Book2);
end;

procedure TFrmMain.ReadOnly1Click(Sender: TObject);
begin
   ReadOnly1.Checked := not ReadOnly1.Checked ;
  (DS.DataSet as TVirtualDataset).readOnly := ReadOnly1.checked;

end;

procedure TFrmMain.Filtered1Click(Sender: TObject);
begin
  Filtered1.Checked := not Filtered1.Checked;
  (DS.DataSet as TVirtualDataset).Filtered := Filtered1.checked;
end;

procedure TFrmMain.SetfilterValue1Click(Sender: TObject);
begin
     Dmtst.SetFilter;
end;

procedure TFrmMain.DSDataChange(Sender: TObject; Field: TField);
begin
   ActiveBuffer.text :=  Tdatasource(Sender).dataset.ActiveBuffer;
end;


procedure TFrmMain.Insert2Click(Sender: TObject);
var
   I : integer;
   TmpDs : TVirtualDataset;
begin
   TmpDs := (DS.DataSet as TVirtualDataset);
   TmpDs.DisableControls;
   Try
   { for I := 1 to 300 do
    begin
      Tmpds.InsertRecord(['insert normal rec' + intToStr(i),i,''])
    end;   }
   for I := 1 to 300 do
   begin
     TmpDS.Insert;
     Tmpds.FieldByName('CHSTR').value := 'insert normal rec' + intToStr(i);
     Tmpds.FieldByName('CHINT').value := i;
     Tmpds.FieldByName('CHFLOAT').value := 1.4 + i;
     TmpDs.Post;
   end;
   finally
     Tmpds.EnableControls;
   end;

end;

procedure TFrmMain.Append2Click(Sender: TObject);
var
   I : integer;
   TmpDs : TVirtualDataset;
begin
   TmpDs := (DS.DataSet as TVirtualDataset);
   TmpDs.DisableControls;
   Try
   for I := 1 to 300 do
   begin
     TmpDS.Append;
     Tmpds.FieldByName('CHSTR').value := 'append normal rec' + intToStr(i);
     Tmpds.FieldByName('CHINT').value := i;
     Tmpds.FieldByName('CHFLOAT').value := 1.5 + i;
     TmpDs.Post;
   end;
   finally
     Tmpds.EnableControls;
   end;

end;

procedure TFrmMain.CommitRecord1Click(Sender: TObject);
begin
     Writedebug('Commit current record');
  (DS.DataSet as TVirtualDataset).CommitRecord;
end;

procedure TFrmMain.SortOnCHSTR1Click(Sender: TObject);
begin
   (DS.DataSet as TVirtualDataset).sortOn('CHSTR',true,false);
end;

procedure TFrmMain.SortOnCHFLOAT1Click(Sender: TObject);
begin
   (DS.DataSet as TVirtualDataset).sortOn('CHFLOAT',true,false);
end;

procedure TFrmMain.Detail1Click(Sender: TObject);
begin
   Dmtst.ShowDet;
end;

end.
